Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 11502)
+++ channels/chan_sip.c	(working copy)
@@ -7479,7 +7479,8 @@
 }
 
 /*! \brief  Report Peer status in character string
- * 	\return 1 if peer is online, -1 if unmonitored */
+ *  \return 0 if peer is unreachable, 1 if peer is online, -1 if unmonitored
+ */
 static int peer_status(struct sip_peer *peer, char *status, int statuslen)
 {
 	int res = 0;
@@ -7600,8 +7601,10 @@
 	char name[256];
 	char iabuf[INET_ADDRSTRLEN];
 	int total_peers = 0;
-	int peers_online = 0;
-	int peers_offline = 0;
+	int peers_mon_online = 0;
+	int peers_mon_offline = 0;
+	int peers_unmon_offline = 0;
+	int peers_unmon_online = 0;
 	char *id;
 	char idtext[256] = "";
 
@@ -7647,21 +7650,17 @@
 			ast_copy_string(name, iterator->name, sizeof(name));
 
 		pstatus = peer_status(iterator, status, sizeof(status));
-		if (pstatus) 	
-			peers_online++;
-		else	{
-			if (pstatus == 0)
-				peers_offline++;
-			else {	/* Unmonitored */
-				/* Checking if port is 0 */
-				if ( ntohs(iterator->addr.sin_port) == 0 ) {
-					peers_offline++;
-				} else {
-					peers_online++;
-				}
-			}
-		}			
-		
+		if (pstatus==1)
+			peers_mon_online++;
+		else if (pstatus==0)
+			peers_mon_offline++;
+		else {
+			if (iterator->addr.sin_port==0)
+				peers_unmon_offline++;
+			else
+				peers_unmon_online++;
+		}
+
 		snprintf(srch, sizeof(srch), FORMAT, name,
 			iterator->addr.sin_addr.s_addr ? ast_inet_ntoa(iabuf, sizeof(iabuf), iterator->addr.sin_addr) : "(Unspecified)",
 			ast_test_flag((&iterator->flags_page2), SIP_PAGE2_DYNAMIC) ? " D " : "   ", 	/* Dynamic or not? */
@@ -7706,7 +7705,7 @@
 	} while(0) );
 
 	if (!s) {
-		ast_cli(fd,"%d sip peers [%d online , %d offline]\n",total_peers,peers_online,peers_offline);
+		ast_cli(fd, "%d sip peers [%d+%d online, %d offline, %d unmonitored]\n", total_peers, peers_mon_online, peers_unmon_online, peers_mon_offline, peers_unmon_offline);
 	}
 
 	if (havepattern)
